std::exp2,std::exp2f,std::exp2l(3)

NAME
std::exp2,std::exp2f,std::exp2l - std::exp2,std::exp2f,std::exp2l

Synopsis
   Defined in header <cmath>
   float exp2 ( float n ); (1) (since C++11)
   float exp2f( float n );
   double exp2 ( double n ); (2) (since C++11)
   long double exp2 ( long double n ); (3) (since C++11)
   long double exp2l( long double n );
   double exp2 ( IntegralType n ); (4) (since C++11)
   1-3) Computes 2 raised to the given power n
   4) A set of overloads or a function template accepting an argument of any integral
   type. Equivalent to (2) (the argument is cast to double).

Parameters
   n - value of floating-point or Integral type

Return value
   If no errors occur, the base-2 exponential of n (2n
   ) is returned.
   If a range error due to overflow occurs, +HUGE_VAL, +HUGE_VALF, or +HUGE_VALL is
   returned.
   If a range error occurs due to underflow, the correct result (after rounding) is
   returned.

Error handling
   Errors are reported as specified in math_errhandling.
   If the implementation supports IEEE floating-point arithmetic (IEC 60559),
     * If the argument is ±0, 1 is returned
     * If the argument is -∞, +0 is returned
     * If the argument is +∞, +∞ is returned
     * If the argument is NaN, NaN is returned

Example
// Run this code
 #include <iostream>
 #include <cmath>
 #include <cerrno>
 #include <cstring>
 #include <cfenv>
 // #pragma STDC FENV_ACCESS ON
 int main()
 {
     std::cout << "exp2(4) = " << std::exp2(4) << '\n'
               << "exp2(0.5) = " << std::exp2(0.5) << '\n'
               << "exp2(-4) = " << std::exp2(-4) << '\n';
     // special values
     std::cout << "exp2(-0) = " << std::exp2(-0.0) << '\n'
               << "exp2(-Inf) = " << std::exp2(-INFINITY) << '\n';
     // error handling
     errno = 0;
     std::feclearexcept(FE_ALL_EXCEPT);
     std::cout << "exp2(1024) = " << std::exp2(1024) << '\n';
     if (errno == ERANGE)
         std::cout << " errno == ERANGE: " << std::strerror(errno) << '\n';
     if (std::fetestexcept(FE_OVERFLOW))
         std::cout << " FE_OVERFLOW raised\n";
 }

Possible output:
 exp2(4) = 16
 exp2(0.5) = 1.41421
 exp2(-4) = 0.0625
 exp2(-0) = 1
 exp2(-Inf) = 0
 exp2(1024) = inf
     errno == ERANGE: Numerical result out of range
     FE_OVERFLOW raised

See also
   exp
   expf returns e raised to the given power (\({\small e^x}\)e^x)
   expl (function)
   (C++11)
   (C++11)
   expm1
   expm1f
   expm1l returns e raised to the given power, minus one (\({\small e^x-1}\)e^x-1)
   (C++11) (function)
   (C++11)
   (C++11)
   log2
   log2f
   log2l base 2 logarithm of the given number (\({\small \log_{2}{x} }\)log[2](x))
   (C++11) (function)
   (C++11)
   (C++11)